#!/usr/bin/perl
###################################################################
###      File: /home/users2/schmid/src/HyTagger/hmm-tagger.perl ###
###    Author: Helmut Schmid                                    ###
###   Purpose:                                                  ###
###   Created: Thu May 19 16:06:22 2005                         ###
###  Modified: Fri Jun 17 12:54:41 2005 (schmid)                ###
### Copyright: Institut fuer maschinelle Sprachverarbeitung     ###
###               Universitaet Stuttgart                        ###
###################################################################

use Getopt::Std;
#use strict;
getopts('dql:f:');
my $opt_l;
my $Smoothing_Weight = (defined $opt_l)? my $opt_l: 1;

###### reading the phoneme mapping ############################

if (defined $opt_f){
    $filename = $opt_f or die;
    open(FILE, $filename) or die;
    while (<FILE>) {
	chomp;
	/(.*)\t(.*)/;
	$gen{$1} = $2;
    }
    close FILE;
}

###### reading the phoneme mapping ############################

my $filename = shift or die;
open(FILE, $filename) or die;
my %possAlign= ();
while (<FILE>) {
  chomp;
  if (/letter\-output\: (.+) \-\-\> (.*)\s*$/){
     my $g = $1;
     my $p = $2;
     $p =~ s/ //g;
     if (exists($possAlign{"$g"})){
	 $a = $possAlign{"$g"};	 
	 push @$a, "$p";
     }
     else{ 
	 my @array = ("$p");
	 $possAlign{"$g"} =\@array;
     }
 }
}
close FILE;
my @array = ("");
$possAlign{"#"} =\@array;
#foreach $key (sort keys %possAlign)
#{ $a = $possAlign{$key};
  #print "key: $key\n";
#foreach $val (sort @$a)
#{print $val."\n";}
#}

###### reading the parameter file ##############################

$filename = shift or die "Error: missing file argument!\n";
open(FILE, $filename) or die "Error: unable to open file \"$filename\"!\n";

my $P = <FILE>;
chomp $P;
my $opt_q;
print STDERR "reading frequency file...\n" unless defined $opt_q;
my $M = 0;
my @Freq;
my @Sum;
my $ItLen = $P;
my $D = ();
if (defined $opt_f){$ItLen = $P*2; }
while (<FILE>) {
  print STDERR "\r$M" if !defined $opt_q && ++$M % 100 == 0;
  chomp;
  my($letters,$count) = split(/\t/);
  my @letter = split(/ /, $letters);
  for( my $i=0; $i<=$ItLen; $i++ ) {
    $letters = join(' ',@letter);
    $Freq[$i]{"$letters"} += $count;
   # print "Freq[ $i ]{ $letters}\n";
    $letters = join(' ',@letter[0..($#letter-1)]);
    $Sum[$i]{"$letters"}+= $count;
    #$CntC[$i]{"$letters"}++;    
    #$letters = graphemelast(\@letter, $letters);
    
    @letter = generalise(\@letter);
    #$letters = join(' ',@letter);
    #$CntRS[$i]{$letters}++;
    #$rletters = join(' ', @letter[0..($#letter-1)]);
    #$CntRC[$i]{$rletters}++;
  }
}
$M = 0;
print STDERR " finished\nestimating kns parameters...\n" unless defined $opt_q;
for( my $i=0; $i<=$ItLen; $i++ ) {
    foreach $seq ( keys %{$Freq[$i]})
    { 
	print STDERR "\r$M" if !defined $opt_q && ++$M % 100 == 0;


	$CntC = "CntC3";# $CntRS = "CntRS3"; $CntRC = "CntRC3";
	if ($Freq[$i]{$seq}==1){$N1[$i]++; $CntC = "CntC1"; }#$CntRS = "CntRS1"; $CntRC = "CntRC1";}
	elsif($Freq[$i]{$seq}==2){$N2[$i]++; $CntC = "CntC2"; }#$CntRS = "CntRS2"; $CntRC = "CntRC2";}
	elsif($Freq[$i]{$seq}==3){$N3[$i]++;}
	elsif($Freq[$i]{$seq}==4){$N4[$i]++;}
	@letter  = split(/ /, $seq);
	$letters = join(' ',@letter[0..($#letter-1)]);
	$$CntC[$i]{"$letters"}++;
	@letter = generalise(\@letter);
	$letters = join(' ',@letter);
	$CntRS[$i]{$letters}++;
	$letters = join(' ', @letter[0..($#letter-1)]);
	$CntRC[$i]{$letters}++;
	
    }
#    $D1[$i]=$N1[$i]/ ($N1[$i] + 2*$N2[$i]);
    $Y[$i]=$N1[$i]/ ($N1[$i] + 2*$N2[$i])if exists($N1[$i]);
next if not exists($N1[$i]);
    $D1[$i] = 1 - 2* $Y[$i] * $N2[$i] / $N1[$i] ;
    $D2[$i] = 2 - 3* $Y[$i] * $N3[$i] / $N2[$i];
    $D3p[$i] = 3 - 4* $Y[$i] * $N4[$i] / $N3[$i] if exists ($N3[$i]);
$D3p[$i] = 3 - 4* $Y[$i] * $N4[$i]  if not exists ($N3[$i]);

$D3p[$i] = 0 if $D3p[$i] <0;
$D1[$i] = 0 if $D1[$i] <0;
$D2[$i] = 0 if $D2[$i] <0;
    #print STDERR  "\n". $CntC[0]{"r- b-.B i-I"}."   ".$CntRS[0]{"2 b-.B i-I l-L"}."   ".$CntRC[0]{"2 b-.B i-I"}."\n";
   }

close FILE;


###### parameter estimation ###################################

print STDERR " finished\nestimating parameters...\n" unless defined $opt_q;

$M = 0;
my @symbols = keys %{$Freq[$ItLen]};
my %Prob =();
#my %Backoff=();
$Prob{''} = 1.0/int(@symbols); # Wahrscheinlichkeit der noch nicht gesehenen Buchstaben-Phon-Einheit
for (my $i=$ItLen; $i>=0; $i-- ){
    foreach my $s (keys %{$Freq[$i]}){
	print STDERR "\r$M" if !defined $opt_q && ++$M % 100 == 0;
	my @letter = split(' ',$s);
	my $c= join(' ',@letter[0..($#letter-1)]);
	@letter = generalise(\@letter);
	my $rs = join(' ',@letter[0..$#letter]);
	my $rc = join(' ',@letter[0..($#letter-1)]);
	$Backoff{$c}=(($D1[$i] * $CntC1[$i]{$c})+($D2[$i]*$CntC2[$i]{$c})+($D3p[$i]*$CntC3[$i]{$c}))/ $Sum[$i]{$c} ;


	 if ($Freq[$i]{$s} == 0){
	$Prob{$s}= $Backoff{$c} * ($CntRS[$i]{$rs} / $CntRC[$i]{$rc});
    }
    elsif ($Freq[$i]{$s} == 1){
	$Prob{$s}=(max($Freq[$i]{$s}-$D1[$i], 0)/ $Sum[$i]{$c}) + 
	    $Backoff{$c} * ($CntRS[$i]{$rs} / $CntRC[$i]{$rc});
    }
    elsif ($Freq[$i]{$s} == 2){
	$Prob{$s}=(max($Freq[$i]{$s}-$D2[$i], 0)/ $Sum[$i]{$c}) +
	    $Backoff{$c} * ($CntRS[$i]{$rs} / $CntRC[$i]{$rc});
    }
    elsif ($Freq[$i]{$s} >= 3){
	$Prob{$s}=(max($Freq[$i]{$s}-$D3p[$i], 0)/ $Sum[$i]{$c}) + 
	    $Backoff{$c} * ($CntRS[$i]{$rs} / $CntRC[$i]{$rc});	
    }

	
	#print "prob($s) : $Prob{$s}= $Freq[$i]{$s}-$D1[$i]/ $Sum[$i]{$c}) +($D1[$i] /  $Sum[$i]{$c} * $CntC[$i]{$c}) * ($CntRS[$i]{$rs} / $CntRC[$i]{$rc})\n";
  }
}
print STDERR "finished\nprocessing input...\n" unless defined $opt_q;

###### input processing ###################################
my @prefix;
my @suffix;
$opt_d;
for(my $i=0; $i<$P; $i++ ) {
  push @prefix, '#';
}
push @suffix, '#';
$M = 0;
my @prev = ();
while (<>) {
  chomp;
  #print STDERR $_;
  s///; s///; s///; $_ = "\L$_";
  print STDERR "\r$M" if !defined $opt_q && ++$M % 100 == 0;
  my(@OLetter,@Letter,@out,%delta);
  @OLetter = split;
  @Letter = @prefix;
  push @Letter, split;
  push @Letter, @suffix;

  my $s = join(' ',@Letter[0..($P-1)]);#stress
 # print $s."\n";
  $delta{$s} = log(1);
#$sflag = 0;
#### generate possible transcriptions and calculate their scores
  for(my $i=$P; $i<=$#Letter; $i++ ) {
      my %ndelta =();
      #print STDERR "\r".int(keys %delta) if !defined $opt_q;
      foreach $s (keys %delta) {
	 # print "\n>>>".$s."\n";
	  my($rs,$ns,$p,@let);	  
	#print $s."\n";
	die unless $s =~ /^(.*)$/;
      my $c = $1;#stress
	  @let = split(/ /,$c);
	  push @let, $Letter[$i];
	  my $l = $Letter[$i];
	  #print $l;
	  my $possMapref = $possAlign{$l};
	  my @possMap = @$possMapref;
	  foreach my $phon (@possMap)
	  {	
	     
	      pop(@let);
	      push(@let,"$l-$phon");
	      my @letter = @let;
	      my $pp = prob(\@letter);
	      $p = $delta{"$s"} + log($pp);
	      $ns = join(' ',@let[1..$#let]);#stress
	      if (!defined $ndelta{"$ns"} || $p > $ndelta{"$ns"})# && (($p > ($lowest + $best)/2)|| $r <10) ) 
		{
		    $ndelta{"$ns"} = $p;
		    $prev[$i]{"$ns"} = $s;
		}
	      print "delta(s) $delta{$s} $pp --> $ns $p\n" if defined $opt_d;
	      $sfl = $sflag;
	  }
	  print "\n" if defined $opt_d; 	 
      }
      %delta =();
      if (int(keys %ndelta) > 15){
	  my @bestX = sort {$ndelta{$b} <=> $ndelta{$a}} keys %ndelta;
	  foreach my $good (@bestX[0..15])
	  {
	      $delta{$good} = $ndelta{$good};
	  }
      }
      else{%delta = %ndelta;}
      #%delta = %ndelta;
      die "Error at line:\n$_\n" if %delta == ();
      print "---------------------------\n" if defined $opt_d;
  }

##### find best solution#####
  my $bestc;
  my $bestdelta = 0;
  foreach my $c (keys %delta) {
  if ($bestdelta == 0 || $bestdelta < $delta{$c}) {
      $bestc = $c;
      $bestdelta = $delta{$c};
    }
  }
  for( my $i=$#Letter; $i>=$P; $i-- ) {
    $out[$i-$P] = $bestc;
    $out[$i-$P] =~ s/.*(\S)\-(\S*)\s*$/$2/;
    
    print "$i-$P $bestc --> $out[$i-$P]\n" if defined $opt_d;
    $bestc = $prev[$i]{$bestc};
   
  }

  print "=====================\n" if defined $opt_d;
  if (defined $opt_d) {
      for( my $i=0; $i<=$#OLetter; $i++ ) {
	  print "$OLetter[$i]-$out[$i] ";
      }
      print "\n";#print STDERR "\n";
  }
  for( my $i=0; $i<=$#OLetter; $i++ ) {
	$out[$i]=~s// /g;
	unless ($out[$i] eq "") {print "$out[$i] ";}# print STDERR "$out[$i] ";}
  }
  print "\n";#print STDERR "\n";
}
print STDERR "finished\n" unless defined $opt_q;


sub prob {
    my $letterref = shift;
    my @letter = @$letterref;
    my $s = join(' ',@letter);
    my $p;
#  print $s."\n";
  if (exists $Prob{$s}) {
    $p = $Prob{$s};
  }
  else {
      my $c= join(' ',@letter[0..($#letter-1)]);
      @letter = generalise(\@letter);
      #my $rs = join(' ',@letter);
     # my $rc = join(' ',@letter[0..($#letter-1)]);
      $p =  prob(\@letter);
      if (exists $Backoff{$c}){
	  $p *= $Backoff{$c}; 
	  print ">>> backoff($c) = $Backoff{$c}\n" if defined $opt_d;
      }
      #else{
#	  $p=($D1[$i] /  $Sum[$i]{$c} * $CntC[$i]{$c}) * ($CntRS[$i]{$rs} / $CntRC[$i]{$rc});
#      }
      #$Prob{$s}=$p;
  }
  print ">>> prob($s) = $p\n" if defined $opt_d;
  
  return $p;
}


sub generalise {
    my $letterref = shift;
    my @letter = @$letterref;
  if ($#letter == 0 || $letter[0] =~ /^/ ||$letter[0] =~ /^\#$/ || not defined($opt_f)) {
    shift @letter;
    return @letter;
  }
  else {
    $letter[0] = gen($letter[0]);
    return @letter;
  }
}

#sub graphemelast{ 
 #   my $letterref = shift;
  #  my @letter = @$letterref;
  #  my $letters = shift;
  #  my $graph = @letter[$#letter];
  #  $graph =~ s/^(.)\-(.*)$/$1/;
  #  $letters .= " $graph";
  #  return $letters;
#}

sub max{
    $a = shift;
    $b = shift;
    ($a < $b) ? ($c = $b) : ($c = $a);
    return $c;
}
#sub is_vowel {
#  my $l = shift;
#  return $gen{$l} eq "1";
#}

sub gen {
  my $p = shift;
  my $x;
  $p =~ s/^.*\-(\.1?)?(\?)?//;
  $p =~ s/\.1?//;
 # print " $gen{$p} $p \n";
  die "Error: no mapping for <$p>!\n" unless exists $gen{$p};
  return ''.$gen{$p};
}
